//
//  NVMapViewController.m
//  nvpolyline
//
//  Created by William Lachance on 10-03-30.
//  Inspired by code and ideas from Craig Spitzkoff and Nicolas Neubauer 2009.
//

#import "NVMapViewController.h"
#import "NVPolylineAnnotationView.h"


@implementation NVMapViewController

- (void)loadView {
	[super loadView];
	
	_mapView = [[[MKMapView alloc] initWithFrame:CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height)] autorelease];
	[_mapView setDelegate:self];
	[self.view addSubview:_mapView];

	// a drive from Dorval to Westmount, Quebec, Canada... as generated by Google Earth
	NSArray *points = [NSArray arrayWithObjects:
					   [[[CLLocation alloc] initWithLatitude:45.43894 longitude:-73.7396] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44073 longitude:-73.73998] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44082000000001 longitude:-73.73992] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44382 longitude:-73.74069] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44612 longitude:-73.74122] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44612 longitude:-73.74122] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44628 longitude:-73.74119] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44649 longitude:-73.74106999999999] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44665999999999 longitude:-73.7409] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44665999999999 longitude:-73.7409] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44676 longitude:-73.74073] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44707999999999 longitude:-73.73990000000001] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44748 longitude:-73.73856000000001] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44748 longitude:-73.73856000000001] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44834 longitude:-73.73581] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44857999999999 longitude:-73.73475999999999] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44863000000001 longitude:-73.73417000000001] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44863000000001 longitude:-73.73300999999999] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44795 longitude:-73.7008] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44784 longitude:-73.69398] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44775 longitude:-73.69092000000001] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44743999999999 longitude:-73.68584] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44728 longitude:-73.68165999999999] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44726 longitude:-73.67901999999999] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44713000000001 longitude:-73.67238] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44691 longitude:-73.67075] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44662 longitude:-73.66947] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44555 longitude:-73.66679000000001] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44460999999999 longitude:-73.66426] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.443 longitude:-73.65927000000001] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44249000000001 longitude:-73.65730000000001] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44229 longitude:-73.6563] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44211 longitude:-73.65433] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44192 longitude:-73.65125999999999] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44196999999999 longitude:-73.65013999999999] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44213000000001 longitude:-73.64919] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44232000000001 longitude:-73.64847] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44268999999999 longitude:-73.64754000000001] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44527000000001 longitude:-73.64261] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44895 longitude:-73.63585999999999] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.44991 longitude:-73.63379] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.45045 longitude:-73.63251] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.4542 longitude:-73.62442] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.4547 longitude:-73.62327000000001] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.45536000000001 longitude:-73.62194] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.46158 longitude:-73.61073] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.46158 longitude:-73.61073] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.4634 longitude:-73.60753] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.4634 longitude:-73.60753] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.46362 longitude:-73.60720999999999] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.46447 longitude:-73.60558] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.46541 longitude:-73.60393000000001] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.46653000000001 longitude:-73.60204] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.46685 longitude:-73.60166] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.46720000000001 longitude:-73.60137] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.46754 longitude:-73.60120000000001] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.4682 longitude:-73.60108] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.46870000000001 longitude:-73.60115] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.46922 longitude:-73.60138000000001] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.46972999999999 longitude:-73.60173] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.46996 longitude:-73.60209] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.4703 longitude:-73.60287] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.47117999999999 longitude:-73.60565] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.47163 longitude:-73.60674] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.47163 longitude:-73.60674] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.47236 longitude:-73.60812] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.47339000000001 longitude:-73.6103] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.47339000000001 longitude:-73.6103] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.47407 longitude:-73.60908000000001] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.47581000000001 longitude:-73.60705] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.47895 longitude:-73.60353000000001] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.48116 longitude:-73.60088] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.48517 longitude:-73.59635] autorelease],
					   [[[CLLocation alloc] initWithLatitude:45.48679000000001 longitude:-73.59443] autorelease],
					   nil];
					   
	NVPolylineAnnotation *annotation = [[[NVPolylineAnnotation alloc] initWithPoints:points mapView:_mapView] autorelease];
	[_mapView addAnnotation:annotation];
	
	// use some magic numbers to create a map region
	MKCoordinateRegion region;
	region.span.longitudeDelta = 0.219727;
	region.span.latitudeDelta = 0.221574;
	region.center.latitude = 45.452424;
	region.center.longitude = -73.662643;
	[_mapView setRegion:region];
}

- (MKAnnotationView *)mapView:(MKMapView *)mapView viewForAnnotation:(id <MKAnnotation>)annotation {

	if ([annotation isKindOfClass:[NVPolylineAnnotation class]]) {
		return [[[NVPolylineAnnotationView alloc] initWithAnnotation:annotation mapView:_mapView] autorelease];
	}
		 
	return nil;
}

- (void)dealloc {
    [super dealloc];
}

@end
